Index: formats/format_sln.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_sln.c,v
retrieving revision 1.6
diff -u -u -r1.6 format_sln.c
--- formats/format_sln.c	21 Apr 2005 06:02:44 -0000	1.6
+++ formats/format_sln.c	2 Jun 2005 15:01:41 -0000
@@ -153,22 +153,24 @@
 
 static int slinear_seek(struct ast_filestream *fs, long sample_offset, int whence)
 {
-	off_t offset=0,min,cur,max;
-
+	off_t min, max, cur;
+	long offset=0, samples;
+	
+	samples = sample_offset * 2; /* SLINEAR is 16 bits mono, so sample_offset * 2 = bytes */
 	min = 0;
 	cur = lseek(fs->fd, 0, SEEK_CUR);
 	max = lseek(fs->fd, 0, SEEK_END);
 	if (whence == SEEK_SET)
-		offset = sample_offset;
+		offset = samples + min;
 	else if (whence == SEEK_CUR || whence == SEEK_FORCECUR)
-		offset = sample_offset + cur;
+		offset = samples + cur;
 	else if (whence == SEEK_END)
-		offset = max - sample_offset;
+		offset = max - samples;
 	if (whence != SEEK_FORCECUR) {
 		offset = (offset > max)?max:offset;
 	}
-	/* always protect against seeking past begining. */
-	offset = (offset < min)?min:offset;
+	/* always protect the header space. */
+	offset = (offset < min) ? min : offset;
 	return lseek(fs->fd, offset, SEEK_SET);
 }
 
